<?php
/**************************************************/
/* La classe tablefig crée l'armature d'une table */
/* et remplit cette armature avec les valeurs     */
/*appropriées. Elle fabrique une chaine affichable*/
/* auteur Jean-Luc Caradeau                       */
/* Ces sources sont protégés par le © du site     */
/* L'auteur en permet l'utilisation gratuitement  */
/* à de fins non commerciales et sous réserve     */
/* de la mension de son nom et de classe tablefig */
/* Ces dispositions s'appliquent également aux    */
/* classes héritières : rect_tab, polygo_tab...   */
/* ainsi qu'au autres sources du pack "nbfig.zip" */
/**************************************************/  
class tablefig{
	// Variables
	var $verti=array(); // tableau de stockage des valeurs numériques de la table
	var $vr1=1; // valeur des nombres du rang 1 modifiable par les classes héritières
	var $diftab; // différence rabilaire entre deux nombres d'ordre o et o+1, modifiable par les classes héritières
	var $maxrang; // dernier rang de la table
	var $maxordre; // dernier ordre de la table
	var $chaine=""; // résultat affiché à l'écran
	//constructeur - syntaxe valable à partir de php5
	function __construct($maxrang,$maxordre){
		$this->maxrang=$maxrang;
		$this->maxordre=$maxordre;
	}
	// crée le premier et le second rang de la table en nombres
	function base_table(){
	  $this->verti[0]=array();
      $this->verti[0][0]='r ↓ / o →';
      for($i=1; $i<= $this->maxordre-1;$i++)$this->verti[0][$i]=$i+2; // un tableau affecté au premier élément de verti et contenant les nombres de 3 à ordfin
      $this->verti[1]=array_fill ( 0 , $this->maxordre-1 , $this->vr1 ); // un tablesu contenant la valeur des éléments du rang 1
	  $this->verti[1][0]=1; // indication du rang
	}
	// fabrication et impression d'une chaine de type "tableau";
	function fait_chaine($typ,$mo=3,$mr=1){
		$fo=$this->maxordre-$mo+1;
		$this->chaine='<div id="container">
		<div style="width:100%; display:flex; font-weight:bold;">'.$typ.' :</div>
		<table id="tbf" class="ntable"><tr id="rang1" class="ntable"><td class="ntable">'.$this->verti[0][0].'</td>'; // cellule 0A
		// remplissage du premier rang avec les nombres allant de l'ordre $mo à maxordre
		for( $i=1; $i<= $fo; $i++ ){
		 $id=$mo-3+$i;
		 $this->chaine.='<td class="ntable">'.$this->verti[0][$id].'</td>';
		}
		$this->chaine.='</tr>';// fin première ligne
	  // remplissage des lignes du tableau avec les valeurs calculées
		for($r=$mr; $r < $this->maxrang; $r++ ){
			$tab=$this->verti[$r];
			$this->chaine.='<tr class="ntable"><td class="ntable">'.$tab[0];
			for( $i=1; $i<= $fo; $i++ ){ // remplissage d'une ligne
				$id=$mo-3+$i;
				$this->chaine.='<td class="ntable">'.$tab[$id].'</td>';
			}
			$this->chaine.='</tr>';
		}
		$this->chaine.='</table></div>';
		echo $this->chaine; 
	}
	// remplissage d'un rangs de verti $act est le nombre figuré d'ordte 3, r est le rang
	function remplit_rang($act,$r){
		$tab=array();
		$tab[0]=$r;
		for($o = 3; $o <= $this->maxordre; $o++){ 
			$i = $o - 2;
			$tab[$i]=$act+($i-1)*$this->diftab;
		}
		$this->verti[$r]=$tab;
		$this->diftab=$tab[1]; // par défaut, la fonction affecte la valeur du nombre d'ordre 3 qui lui a été transmise, la classe héritière modifie cette valeur si nécessaire
	}
	
	// Les fonctions de calcul du solide d'ordre3 sont pour plus de clarté placées dans des classes héritiètes. 
}// fin de classe
?>